<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class Fm0000000HistoricoTransferenciaFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getHistoricoVistorias()
    {
        $sql = "SELECT FCM_LOGTRANSFGERCHK.NRGERENCIAMENTOCHK as id, ('Vistoria - ' || FCM_GERENCIAMENTOCHK.NMGERENCIAMENTOCHK) AS NOME, 
                        TO_CHAR(FCM_GERENCIAMENTOCHK.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') as DTHORAAGEND, ORIGEM.NMOPERADOR AS FUNCORIGEM,
                        DESTINO.NMOPERADOR AS FUNCDESTINO, TO_CHAR(FCM_LOGTRANSFGERCHK.DTINCLUSAO, 'DD/MM/YYYY HH24:MI') as DTINCLUSAO, 
                        RESPDESTINOONSAVEL.NMOPERADOR AS RESPONSAVEL
                FROM FCM_LOGTRANSFGERCHK
                LEFT JOIN FCM_GERENCIAMENTOCHK
                    ON FCM_LOGTRANSFGERCHK.NRGERENCIAMENTOCHK = FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK
                LEFT JOIN OPERADOR ORIGEM
                    ON FCM_LOGTRANSFGERCHK.CDOPERADORORIGEM = ORIGEM.CDOPERADOR
                LEFT JOIN OPERADOR DESTINO
                    ON FCM_LOGTRANSFGERCHK.CDOPERADORDESTINO = DESTINO.CDOPERADOR
                LEFT JOIN OPERADOR RESPDESTINOONSAVEL
                    ON FCM_LOGTRANSFGERCHK.CDOPERREALIZATRANSF = RESPDESTINOONSAVEL.CDOPERADOR";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getHistoricoTarefas()
    {
        $sql = "SELECT FCM_LOGTRANSFAGEND.NRCHECKLISTAGEND as id, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND AS NOME, TO_CHAR(FCM_CHECKLISTAGEND.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') as DTHORAAGEND, ORIGEM.NMOPERADOR AS FUNCORIGEM,
                        DESTINO.NMOPERADOR AS FUNCDESTINO, TO_CHAR(FCM_LOGTRANSFAGEND.DTINCLUSAO, 'DD/MM/YYYY HH24:MI') as DTINCLUSAO, RESPDESTINOONSAVEL.NMOPERADOR AS RESPONSAVEL
                FROM FCM_LOGTRANSFAGEND
                LEFT JOIN FCM_CHECKLISTAGEND
                    ON FCM_LOGTRANSFAGEND.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
                LEFT JOIN OPERADOR ORIGEM
                    ON FCM_LOGTRANSFAGEND.CDOPERADORORIGEM = ORIGEM.CDOPERADOR
                LEFT JOIN OPERADOR DESTINO
                    ON FCM_LOGTRANSFAGEND.CDOPERADORDESTINO = DESTINO.CDOPERADOR
                LEFT JOIN OPERADOR RESPDESTINOONSAVEL
                    ON FCM_LOGTRANSFAGEND.CDOPERREALIZATRANSF = RESPDESTINOONSAVEL.CDOPERADOR
                ORDER BY DTINCLUSAO DESC";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
