<?php

namespace FM\Service;

use FM\Factory\EscoposTarefaFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class EscoposTarefaService
{

    protected $EscoposTarefaFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct(EscoposTarefaFactory $EscoposTarefaFactory, Environment $Environment, NewCode $newCode, EntityManager $entityManager)
    {
        $this->EscoposTarefaFactory = $EscoposTarefaFactory;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
        $this->connection = $entityManager->getConnection();
    }

    public function getEscopo()
    {
        return $this->EscoposTarefaFactory->getEscopo();
    }

    public function escoposComAtividadeChk()
    {
        return $this->EscoposTarefaFactory->escoposComAtividadeChk();
    }

    public function setEscopo($params)
    {
        $this->connection->beginTransaction();

        try {
            $this->EscoposTarefaFactory->setEscopo(array(
                "NRESCOPOSTAREFA" => $this->newCode->getCodeByTableName('FCM_ESCOPOSTAREFA', $this->Environment->getNrOrg(), 1, 10, true),
                "NMESCOPOSTAREFA" => $params["NMESCOPOSTAREFA"],
                "NRORG" =>  $this->Environment->getNrOrg()
            ));

            $this->connection->commit();
            $response = "OK";
        } catch (\Exception $e) {
            $this->connection->rollback();
            $response = ($e->getMessage());
        }
        return [$response];
    }
}
