/* eslint-disable */
import { Utilities } from '@/util/Utilities';
import {
    DialogService, Modal, ModalService, TextInput,
} from '@zeedhi/common';
import { IEventParam, Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class Fm00003004EscopoServicoController {
    private modalEscopo!: Modal;

    public controlarEdicao: boolean = false;

    public async abrirModal() {
        this.modalEscopo = await ModalService.createFromJsonPost('', { jsonPath: '/fm_00003_000_checklist/modal/fm_00003_004_salvar_escopo' });
        await this.modalEscopo.show();
    }

    public fecharModal() {
        this.modalEscopo.hide();
        this.modalEscopo?.destroy();
    }

    public salvarEscopo({ event }: any) {
        event.preventDefault();

        const grid = Metadata.getInstance<TekGrid>('tek-grid-escopo-servico');

        if (Utilities.validateGrid(grid)) {
            Utilities.save('/salvarEscopoServico', grid.getEditedRows()).then(() => {
                grid.datasource.get();
                grid.cancelEditedRows();
            });
        }
    }
    
    public canEditRow({ row }: any) {
        return row['__added_row'] === true;
    }

    public adicionarNovaLinha({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ NRESCOPOSTAREFA: newId }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`NMESCOPOSTAREFA_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public dialogInativarEscopos({ event }: any) {
        Utilities.showConfirmDeleteMessage(event, 'Fm00003004EscopoServicoController.inativarEscopos', 'Inativar Registros', 'Deseja realmente inativar todos os registros selecionados?');
    }

    public inativarEscopos() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-escopo-servico');
        Utilities.deleteInfoGrid('/inativarEscopos', { component: grid }).then(() => {
            grid.datasource.get();
            DialogService.hide();
        });
    }
}
