/* eslint-disable */
import {
    Metadata, Http,
} from '@zeedhi/core';
import {
    Button, Modal, ModalService, Form, Select, TextInput, LoadingService,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';
import { ZdSelect } from '@zeedhi/vuetify';

export class ControllerParametrizacaoGeral {
    private mnemonicosModal!: Modal;

    public modificarUtilizacaoMascara({ component }: any) {
        //     const utilizarMascara = (component.value === "N");
        //     const mascara = Metadata.getInstance<TextInput>('InputMascara');
        //     mascara.disabled = utilizarMascara;
        //     Metadata.getInstance<Button>('BtnMnemonicos').disabled = utilizarMascara;
        //     Metadata.getInstance<Select>('SelectPermissao').disabled = utilizarMascara;
        //     if (utilizarMascara) {
        //         mascara.removeValidation('required');
        //     } else {
        //         mascara.addValidation('required');
        //     }
    }

    public salvarParametrizacoes() {
        const form = Metadata.getInstance<Form>('formParametrizacao_dropBoxTarefas');
        const formLocais = Metadata.getInstance<Form>('formParametrizacao_dropBoxLocaisAtendimento');
        if (form.validate() && formLocais.validate()) {
            const paramConflito = Metadata.getInstance<ZdSelect>('selectValidacaoConflito').value;
            const permiteGeolocalizacao = Metadata.getInstance<ZdSelect>('geolocalizacaoAtendimento').value;
            const iniciarTarGeolocalizacao = Metadata.getInstance<ZdSelect>('geolocalizacaoIniciarTarefa').value;
            LoadingService.show();
            Http.post('/salvarParametrizacoes', {
                CONFLITO: paramConflito,
                PERGEOLOCALIZACAO: permiteGeolocalizacao,
                INICIARTARGEOLOCALIZACAO: iniciarTarGeolocalizacao,
            }).then(() => {
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    public async getParametrizacoes() {
        let retorno: any = [];
        await Http.get('/getParametrizacoes').then((response) => {
            retorno = response;
            if (response.data.length > 0) {
                Metadata.getInstance<Select>('geolocalizacaoAtendimento').value = response.data[0]['IDUTILIZAGEOLOCAL'];
                Metadata.getInstance<Select>('geolocalizacaoIniciarTarefa').value = response.data[0]['IDUTILIZAGEOLOCALINITAR'];
                Metadata.getInstance<ZdSelect>('selectValidacaoConflito').value = response.data[0]['IDVALIDACRIATAREFA'];
                this.changeGeolocalizacaoLocalAtendimento(retorno.data[0]);
            }
        })
    }

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(`formParametrizacao_${component.name}`);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public changeGeolocalizacaoLocalAtendimento(permiteGeo: any) {
        const inicioTarefaGeo = Metadata.getInstance<Select>('geolocalizacaoIniciarTarefa');
        const exibeGeolocalizacao = Metadata.getInstance<Select>('geolocalizacaoAtendimento');
        if (permiteGeo.IDUTILIZAGEOLOCAL === 'N' || exibeGeolocalizacao.value === 'N') {
            inicioTarefaGeo.value = 'N';
            inicioTarefaGeo.disabled = true;
        } else if (exibeGeolocalizacao.value === 'S') {
            inicioTarefaGeo.disabled = false;
        }
    }

    public async openMnemonicosModal() {
        this.mnemonicosModal = await ModalService.create({
            name: 'mnemonicosModal',
            children: [
                {
                    name: 'mnemonicostHeader',
                    component: 'ZdHeader',
                    color: 'transparent',
                    padless: true,
                    elevation: 0,
                    leftSlot: [
                        {
                            name: 'titleText',
                            component: 'ZdText',
                            text: 'Mnemônicos',
                        },
                    ],
                    rightSlot: [
                        {
                            name: "closeModal",
                            component: "ZdButton",
                            iconName: "mdi-close",
                            icon: true,
                            events: {
                                click: "{{ControllerParametrizacaoGeral.closeMnemonicosModal}}"
                            }
                        },
                    ],
                },
                {
                    name: 'form',
                    component: 'ZdForm',
                    children: [
                        {
                            name: 'MnemonicoSeq',
                            component: 'ZdText',
                            text: '[SEQ]',
                            grid: {
                                cols: 3,
                            }
                        },
                        {
                            name: 'DescricaoSeq',
                            component: 'ZdText',
                            text: '– Número sequencial para geração da máscara.',
                            grid: {
                                cols: 9,
                            }
                        },
                        {
                            name: 'MnemonicoSetor',
                            component: 'ZdText',
                            text: '[SETOR]',
                            grid: {
                                cols: 3,
                            }
                        },
                        {
                            name: 'DescricaoSetor',
                            component: 'ZdText',
                            text: '– Nome do setor.',
                            grid: {
                                cols: 9,
                            }
                        },
                        {
                            name: 'MnemonicoLocalAtendimento',
                            component: 'ZdText',
                            text: '[NMABLOC]',
                            grid: {
                                cols: 3,
                            }
                        },
                        {
                            name: 'DescricaoLocalAtendimento',
                            component: 'ZdText',
                            text: '– Nome abreviado do local de atendimento.',
                            grid: {
                                cols: 9,
                            }
                        },
                        {
                            name: 'MnemonicoLocalSuperior',
                            component: 'ZdText',
                            text: '[NMABLOCS]',
                            grid: {
                                cols: 3,
                            }
                        },
                        {
                            name: 'DescricaoLocalSuperior',
                            component: 'ZdText',
                            text: '– Nome abreviado do local de atendimento superior.',
                            grid: {
                                cols: 9,
                            }
                        },
                        {
                            name: 'MnemonicoTodosLocais',
                            component: 'ZdText',
                            text: '[NMABLOCSALL{}]',
                            grid: {
                                cols: 3,
                            }
                        },
                        {
                            name: 'DescricaoTodosLocais',
                            component: 'ZdText',
                            text: '– Nome abreviado de todos os locais de atendimento superiores, no caso o delimitador que separa os locais, deve ser colocado dento das chaves.',
                            grid: {
                                cols: 9,
                            }
                        },
                    ],
                },
            ],
        });
        this.mnemonicosModal.show();
    }

    public closeMnemonicosModal() {
        this.mnemonicosModal.hide();
        this.mnemonicosModal?.destroy();
    }

}
